// Vanocni programovatelne osvetleni
// Autor: David Benda, Prostejov, Czech republic
// Vytvoreno: 1-2-2023  v. 1.0
// Verze:  22-02-2023  v 1.1

#include <Arduino.h>
#include <EEPROM.h>
int adress = 0; 
int potPin = A0; // Potenciometr
int fotPin = A1; // Fotoodpor  
int potProm = 0;   
int fotProm = 0;
int night = 0; // If 1 then it`s night
int pozadavek = 920; // Default value
volatile int stiskTlacitka = 0; // Po stisku je 1 a zamezuje vicenasobnemu stisku
volatile int zapisdoEeprom = 0; // Pocet zapisu do Eeprom 
int zdrzeni = 800; // Default value
int intenzita = 976; // Default value
int Led1 = 3; // Colorful LED chain - the cheapest from the KIK store :-) 
int Led2 = 4; // Colorful LED chain - the cheapest from the KIK store :-) 
int Led3 = 5; // Colorful LED chain - double lenght
int Led4 = 6; // Colorful LED chain - the cheapest from the KIK store :-) 
int Led5 = 7; // Colorful LED chain - the cheapest from the KIK store :-) 
int Led6 = 8; // Not used
int Led7 = 9; // White LED chain
int Led8 = 10; // Its night LED - Green
int Led9 = 11; // Its day LED - Red
void setup() 
{
  pinMode(2, INPUT_PULLUP); // Button For Interrupt 
  pinMode(potPin, INPUT); // Potentiometer  50k linear
  pinMode(fotPin, INPUT); // Photoresistor and rezistor 12.26 k ohm
  pinMode(Led1, OUTPUT); // Colorful LED chain
  pinMode(Led2, OUTPUT); // Colorful LED chain
  pinMode(Led3, OUTPUT); // Colorful LED chain - double lenght
  pinMode(Led4, OUTPUT); // Colorful LED chain
  pinMode(Led5, OUTPUT); // Colorful LED chain
  pinMode(Led6, OUTPUT); // Not used
  pinMode(Led7, OUTPUT); // White LED chain
  pinMode(Led8, OUTPUT); // GREEN - now its night - RGB 200 ohm resistor
  pinMode(Led9, OUTPUT); // RED - now its day - RGB 200 ohm resisitor
  pinMode(13, OUTPUT); // LED on the board
  attachInterrupt(digitalPinToInterrupt(2),tlacitko, FALLING);
  EEPROM.get(0, pozadavek);
  if (pozadavek < 0) {pozadavek = 0;}; // Muze se uplatnit pri prvnim spusteni
  if (pozadavek > 1023) {pozadavek = 1022;}; // Muze se uplatnit po prvnim spusteni
  Serial.begin(9600); 
}

 void tlacitko()
 { stiskTlacitka = stiskTlacitka + 1; 
 if (stiskTlacitka == 1) {pozadavek=intenzita; zapisdoEeprom = zapisdoEeprom+1; EEPROM.put(0, intenzita); digitalWrite(13, HIGH); };
 }

void loop()
{
digitalWrite(Led1, LOW); 
digitalWrite(Led2, LOW);
digitalWrite(Led3, LOW);
digitalWrite(Led4, LOW);
digitalWrite(Led5, LOW);
digitalWrite(Led7, LOW);
digitalWrite(13, LOW); 
detachInterrupt(0);
for (int v = 0; v < 20; v++)
{
fotProm = analogRead(fotPin);
intenzita = intenzita+fotProm;
}
intenzita = intenzita/20;  // Vytvori prumer z 20ti hodnot
attachInterrupt(digitalPinToInterrupt(2),tlacitko, FALLING);  

if (intenzita > pozadavek) { night=1; digitalWrite(Led8, HIGH); digitalWrite(Led9, LOW); } else {night=0;}; 

if (night == 1) {
 for (int i = 0; i < 15; i++) //Block Nr.1
 {
potProm = analogRead(potPin);
zdrzeni = potProm; 
digitalWrite(Led7, HIGH); 
digitalWrite(Led1, HIGH);
digitalWrite(Led2, LOW);
digitalWrite(Led3, LOW);
digitalWrite(Led4, LOW);
digitalWrite(Led5, LOW);
delay(zdrzeni);
digitalWrite(Led1, LOW);
digitalWrite(Led2, HIGH);
digitalWrite(Led3, LOW);
digitalWrite(Led4, LOW);
digitalWrite(Led5, LOW);
delay(zdrzeni);
digitalWrite(Led1, LOW);
digitalWrite(Led2, LOW);
digitalWrite(Led3, HIGH);
digitalWrite(Led4, LOW);
digitalWrite(Led5, LOW);
delay(zdrzeni);
digitalWrite(Led1, LOW);
digitalWrite(Led2, LOW);
digitalWrite(Led3, LOW);
digitalWrite(Led4, HIGH);
digitalWrite(Led5, LOW);
delay(zdrzeni);
digitalWrite(Led1, LOW);
digitalWrite(Led2, LOW);
digitalWrite(Led3, LOW);
digitalWrite(Led4, LOW);
digitalWrite(Led5, HIGH);
digitalWrite(13, LOW); 
delay(zdrzeni);
 } 
 } else { digitalWrite(Led8, LOW); digitalWrite(Led9, HIGH);delay(1000); }

 if (night == 1)
 {
 for (int i = 0; i < 15; i++) //Block Nr.2
 {
potProm = analogRead(potPin);
zdrzeni = potProm; 
digitalWrite(Led7, HIGH);
digitalWrite(Led1, LOW);
digitalWrite(Led2, LOW);
digitalWrite(Led3, LOW);
digitalWrite(Led4, LOW);
digitalWrite(Led5, HIGH);
delay(zdrzeni);
digitalWrite(Led1, LOW);
digitalWrite(Led2, LOW);
digitalWrite(Led3, LOW);
digitalWrite(Led4, HIGH);
digitalWrite(Led5, LOW);
delay(zdrzeni);
digitalWrite(Led1, LOW);
digitalWrite(Led2, LOW);
digitalWrite(Led3, HIGH);
digitalWrite(Led4, LOW);
digitalWrite(Led5, LOW);
delay(zdrzeni);
digitalWrite(Led1, LOW);
digitalWrite(Led2, HIGH);
digitalWrite(Led3, LOW);
digitalWrite(Led4, LOW);
digitalWrite(Led5, LOW);
delay(zdrzeni);
digitalWrite(Led1, HIGH);
digitalWrite(Led2, LOW);
digitalWrite(Led3, LOW);
digitalWrite(Led4, LOW);
digitalWrite(Led5, LOW);
digitalWrite(13, LOW); 
delay(zdrzeni);  
 } 
 } else { digitalWrite(Led8, LOW); digitalWrite(Led9, HIGH);delay(1000); }
digitalWrite(Led1, LOW);
for (int v = 0; v < 20; v++)
{
fotProm = analogRead(fotPin);
intenzita = intenzita+fotProm;
}
intenzita = intenzita/20;  // Vytvori prumer z 20ti hodnot
attachInterrupt(digitalPinToInterrupt(2),tlacitko, FALLING);  
if (intenzita > pozadavek) { night=1; digitalWrite(Led8, HIGH); digitalWrite(Led9, LOW); } else {night=0;}; 
if (night == 1)
{
for (int i = 0; i < 15; i++) //Block Nr.3
{
potProm = analogRead(potPin);
zdrzeni = potProm; 
digitalWrite(Led7, LOW);
digitalWrite(Led1, LOW);
digitalWrite(Led2, LOW);
digitalWrite(Led3, LOW);
digitalWrite(Led4, LOW);
digitalWrite(Led5, LOW);
delay(zdrzeni/100);
digitalWrite(Led1, LOW);
digitalWrite(Led2, LOW);
digitalWrite(Led3, HIGH);
digitalWrite(Led4, LOW);
digitalWrite(Led5, LOW);
delay(zdrzeni);
digitalWrite(Led1, LOW);
digitalWrite(Led2, HIGH);
digitalWrite(Led3, LOW);
digitalWrite(Led4, HIGH);
digitalWrite(Led5, LOW);
delay(zdrzeni);
digitalWrite(Led1, HIGH);
digitalWrite(Led2, LOW);
digitalWrite(Led3, LOW);
digitalWrite(Led4, LOW);
digitalWrite(Led5, HIGH);
digitalWrite(13, LOW); 
delay(zdrzeni);  
} 
}
else { digitalWrite(Led8, LOW); digitalWrite(Led9, HIGH);delay(1000); }
digitalWrite(13, LOW); 
if (night == 1)
{
 for (int i = 0; i < 15; i++) //Block Nr.4
{ potProm = analogRead(potPin);
zdrzeni = potProm; 
digitalWrite(Led7, LOW);
digitalWrite(Led1, LOW);
digitalWrite(Led2, LOW);
digitalWrite(Led3, LOW);
digitalWrite(Led4, LOW);
digitalWrite(Led5, LOW);
delay(zdrzeni);
digitalWrite(Led1, LOW);
digitalWrite(Led2, LOW);
digitalWrite(Led3, HIGH);
digitalWrite(Led4, LOW);
digitalWrite(Led5, LOW);
delay(zdrzeni);
digitalWrite(Led1, LOW);
digitalWrite(Led2, HIGH);
digitalWrite(Led3, HIGH);
digitalWrite(Led4, HIGH);
digitalWrite(Led5, LOW);
delay(zdrzeni);
digitalWrite(Led1, HIGH);
digitalWrite(Led2, HIGH);
digitalWrite(Led3, HIGH);
digitalWrite(Led4, HIGH);
digitalWrite(Led5, HIGH);
delay(zdrzeni);
digitalWrite(Led1, HIGH);
digitalWrite(Led2, HIGH);
digitalWrite(Led3, LOW);
digitalWrite(Led4, HIGH);
digitalWrite(Led5, HIGH);
delay(zdrzeni);
digitalWrite(Led1, HIGH);
digitalWrite(Led2, LOW);
digitalWrite(Led3, LOW);
digitalWrite(Led4, LOW);
digitalWrite(Led5, HIGH);
digitalWrite(13, LOW);
delay(zdrzeni);
 } 
 }
 else { digitalWrite(Led8, LOW); digitalWrite(Led9, HIGH);delay(1000); }
 
  //Block Nr.5 - All LEDs ON
potProm = analogRead(potPin); 
zdrzeni = potProm; 
if (night == 1) {
digitalWrite(Led1, HIGH); //vsechno sviti zdrzeni*20 potom jde cyklus od zacatku
digitalWrite(Led2, HIGH);
digitalWrite(Led3, HIGH);
digitalWrite(Led4, HIGH);
digitalWrite(Led5, HIGH);
digitalWrite(Led7, HIGH);
digitalWrite(13, LOW); //Turn Off LED on the board
delay(zdrzeni*20);
}
else { digitalWrite(Led8, LOW); digitalWrite(Led9, HIGH);delay(1000); }
stiskTlacitka=0; 
 }
 
